DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Data Grid - Edit State Management

Our JavaScript DataGrid component manages its edit state automatically. If your use case requires full control over the editing process, you can use the API members below to manage state manually.

Backend API
$(() => { const URL = 'https://js.devexpress.com/Demos/NetCore/api/DataGridWebApi'; const loadPanel = $('#loadPanel').dxLoadPanel({ position: { of: '#gridContainer', }, visible: false, }).dxLoadPanel('instance'); loadPanel.show(); sendRequest(`${URL}/Orders?skip=700`) .always(() => { loadPanel.hide(); }) .then((data) => { dataGrid.option('dataSource', data); }); const dataGrid = $('#gridContainer').dxDataGrid({ keyExpr: 'OrderID', showBorders: true, dataSource: [], editing: { mode: 'row', allowAdding: true, allowUpdating: true, allowDeleting: true, }, pager: { visible: true, }, repaintChangesOnly: true, onOptionChanged(e) { if (e.name === 'editing') { const editRowKey = e.component.option('editing.editRowKey'); let changes = e.component.option('editing.changes'); $('#editRowKey').text(editRowKey === null ? 'null' : editRowKey); changes = changes.map((change) => ({ type: change.type, key: change.type !== 'insert' ? change.key : undefined, data: change.data, })); $('#changes').text(JSON.stringify(changes, null, ' ')); } }, onSaving(e) { const change = e.changes[0]; if (change) { e.cancel = true; loadPanel.show(); e.promise = saveChange(URL, change) .always(() => { loadPanel.hide(); }) .then((data) => { let orders = e.component.option('dataSource'); if (change.type === 'insert') { change.data = data; } orders = DevExpress.data.applyChanges(orders, [change], { keyExpr: 'OrderID' }); e.component.option({ dataSource: orders, editing: { editRowKey: null, changes: [], }, }); }); } }, columns: [{ dataField: 'OrderID', allowEditing: false, }, { dataField: 'ShipName', }, { dataField: 'ShipCountry', }, { dataField: 'ShipCity', }, { dataField: 'ShipAddress', }, { dataField: 'OrderDate', dataType: 'date', }, { dataField: 'Freight', }], }).dxDataGrid('instance'); function saveChange(url, change) { switch (change.type) { case 'insert': return sendRequest(`${url}/InsertOrder`, 'POST', { values: JSON.stringify(change.data) }); case 'update': return sendRequest(`${url}/UpdateOrder`, 'PUT', { key: change.key, values: JSON.stringify(change.data) }); case 'remove': return sendRequest(`${url}/DeleteOrder`, 'DELETE', { key: change.key }); default: return null; } } function sendRequest(url, method = 'GET', data = {}) { const d = $.Deferred(); $.ajax(url, { method, data, cache: false, xhrFields: { withCredentials: true }, }).then((result) => { d.resolve(method === 'GET' ? result.data : result); }, (xhr) => { d.reject(xhr.responseJSON ? xhr.responseJSON.Message : xhr.statusText); }); return d.promise(); } });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="js/dx.all.js?v=26.1.3"></script> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="loadPanel"></div> <div id="gridContainer"></div> <div class="options"> <div class="caption">Options</div> <div class="option"> <span>Edit Row Key:</span> <div id="editRowKey">null</div> </div> <div class="option"> <span>Changes:</span> <div id="changes">[]</div> </div> </div> </div> </body> </html>
#gridContainer { height: 440px; } .options { padding: 20px; margin-top: 20px; background-color: rgba(191, 191, 191, 0.15); } .caption { margin-bottom: 10px; font-weight: 500; font-size: 18px; } .option { margin-bottom: 10px; } .option > span { position: relative; margin-right: 10px; } .option > div { display: inline-block; font-weight: bold; }

Component Properties

  • editing.editRowKey
    The key for the row being edited.

  • editing.editColumnName
    The name or data field of the column being edited.

  • editing.changes
    Pending row changes.

You can get and set these properties at runtime to access and change edit state. In this demo, the onOptionChanged function gets editRowKey and changes property values and displays them under the JavaScript DataGrid.

Utility Method

Event Handlers

  • onSaving / onSaved
    Functions that are called before / after pending row changes are saved via the UI or programmatically.

  • onEditCanceling / onEditCanceled
    Functions that are called before / after editing is canceled and pending row changes are discarded.

Use these functions to perform custom actions. In this demo, the onSaving function sends pending changes to a server. The function's parameter e contains fields for this capability. To implement the same in your application, follow these steps:

  1. Disable built-in edit state management
    Set the e.cancel field to true.

  2. Send a request to the server
    Pending changes are stored in the e.changes array. This array has only a single element in all edit modes, except for batch. Check if this element is not empty and send it to the server.

  3. Apply the same changes to a local array
    If the server successfully saves changes, call the applyChanges method to save the same changes in a local array.

  4. Update the JavaScript DataGrid's data source and reset edit state
    Assign the local array to the dataSource, null to the editRowKey, and an empty array to the changes property.

<dx-load-panel [position]="loadPanelPosition" [visible]="isLoading">
</dx-load-panel>
<dx-data-grid
id="gridContainer"
keyExpr="OrderID"
[dataSource]="orders$ | async"
[showBorders]="true"
[repaintChangesOnly]="true"
(onSaving)="onSaving($event)"
>
<dxo-data-grid-editing
mode="row"
[allowAdding]="true"
[allowDeleting]="true"
[allowUpdating]="true"
[(changes)]="changes"
[(editRowKey)]="editRowKey"
></dxo-data-grid-editing>
<dxo-data-grid-pager [visible]="true"></dxo-data-grid-pager>
<dxi-data-grid-column
dataField="OrderID"
[allowEditing]="false"
></dxi-data-grid-column>
<dxi-data-grid-column dataField="ShipName"></dxi-data-grid-column>
<dxi-data-grid-column dataField="ShipCountry"></dxi-data-grid-column>
<dxi-data-grid-column dataField="ShipCity"></dxi-data-grid-column>
<dxi-data-grid-column dataField="ShipAddress"></dxi-data-grid-column>
<dxi-data-grid-column
dataField="OrderDate"
dataType="date"
></dxi-data-grid-column>
<dxi-data-grid-column dataField="Freight"></dxi-data-grid-column>
</dx-data-grid>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Edit Row Key:</span>
<div id="editRowKey">{{
editRowKey === null ? "null" : editRowKey.toString()
}}</div>
</div>
<div class="option">
<span>Changes:</span>
<div id="changes">{{ changesText }}</div>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, OnInit, OnDestroy, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { provideHttpClient, withFetch } from '@angular/common/http';
import { AsyncPipe } from '@angular/common';
import { DxLoadPanelModule } from 'devextreme-angular';
import { Observable, Subscription } from 'rxjs';
import { DxDataGridModule, DxDataGridTypes } from 'devextreme-angular/ui/data-grid';
import { Service, Order, Change } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
preserveWhitespaces: true,
imports: [
AsyncPipe,
DxDataGridModule,
DxLoadPanelModule,
],
})
export class AppComponent implements OnInit, OnDestroy {
ordersSubscription: Subscription;
orders$: Observable<Order[]>;
changes: Change<Order>[] = [];
editRowKey?: number = null;
isLoading = false;
loadPanelPosition = { of: '#gridContainer' };
constructor(private service: Service) { }
ngOnInit() {
this.orders$ = this.service.getOrders();
this.isLoading = true;
this.ordersSubscription = this.orders$.subscribe(() => {
this.isLoading = false;
});
}
get changesText(): string {
return JSON.stringify(this.changes.map((change) => ({
type: change.type,
key: change.type !== 'insert' ? change.key : undefined,
data: change.data,
})), null, ' ');
}
onSaving(e: DxDataGridTypes.SavingEvent) {
const change = e.changes[0];
if (change) {
e.cancel = true;
e.promise = this.processSaving(change);
}
}
async processSaving(change: Change<Order>) {
this.isLoading = true;
try {
await this.service.saveChange(change);
this.editRowKey = null;
this.changes = [];
} finally {
this.isLoading = false;
}
}
ngOnDestroy() {
this.ordersSubscription.unsubscribe();
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
provideHttpClient(withFetch()),
],
});
::ng-deep #gridContainer {
height: 440px;
}
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
margin-bottom: 10px;
font-weight: 500;
font-size: 18px;
}
.option {
margin-bottom: 10px;
}
.option > span {
position: relative;
margin-right: 10px;
}
::ng-deep .option > div {
display: inline-block;
font-weight: bold;
}
import { Injectable } from '@angular/core';
import { HttpClient, HttpParams } from '@angular/common/http';
import { BehaviorSubject, Observable, lastValueFrom } from 'rxjs';
import applyChanges from 'devextreme/data/apply_changes';
export class Order {
OrderID: number;
ShipName: string;
ShipCountry: string;
ShipCity: string;
ShipAddress: string;
OrderDate: string;
Freight: number;
}
export class Change<T> {
type: 'insert' | 'update' | 'remove';
key: string;
data: Partial<T>;
}
class Response<T> {
data: T[];
}
@Injectable()
export class Service {
private orders$ = new BehaviorSubject<Order[]>([]);
private url = 'https://js.devexpress.com/Demos/NetCore/api/DataGridWebApi';
constructor(private http: HttpClient) { }
updateOrders(change: Change<Order>, data: Order) {
change.data = data;
const orders = applyChanges(this.orders$.getValue(), [change], { keyExpr: 'OrderID' });
this.orders$.next(orders);
}
getOrders(): Observable<Order[]> {
lastValueFrom(this.http.get(`${this.url}/Orders?skip=700`, { withCredentials: true }))
.then((data: Response<Order>) => {
this.orders$.next(data.data);
});
return this.orders$.asObservable();
}
async insert(change: Change<Order>): Promise<Order> {
const httpParams = new HttpParams({ fromObject: { values: JSON.stringify(change.data) } });
const httpOptions = { withCredentials: true, body: httpParams };
const data = await lastValueFrom(this.http.post<Order>(`${this.url}/InsertOrder`, httpParams, httpOptions));
this.updateOrders(change, data);
return data;
}
async update(change: Change<Order>): Promise<Order> {
const httpParams = new HttpParams({ fromObject: { key: change.key, values: JSON.stringify(change.data) } });
const httpOptions = { withCredentials: true, body: httpParams };
const data = await lastValueFrom(this.http.put<Order>(`${this.url}/UpdateOrder`, httpParams, httpOptions));
this.updateOrders(change, data);
return data;
}
async remove(change: Change<Order>): Promise<Order> {
const httpParams = new HttpParams({ fromObject: { key: change.key } });
const httpOptions = { withCredentials: true, body: httpParams };
const data = await lastValueFrom(this.http.delete<Order>(`${this.url}/DeleteOrder`, httpOptions));
this.updateOrders(change, data);
return data;
}
saveChange(change: Change<Order>): Promise<Order> {
switch (change.type) {
case 'insert':
return this.insert(change);
case 'update':
return this.update(change);
case 'remove':
return this.remove(change);
default:
return null;
}
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "21.2.17"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

<template>
<div>
<DxLoadPanel
:position="loadPanelPosition"
:visible="isLoading"
/>
<DxDataGrid
id="gridContainer"
key-expr="OrderID"
:data-source="orders"
:show-borders="true"
:repaint-changes-only="true"
@saving="onSaving"
>
<DxEditing
mode="row"
:allow-adding="true"
:allow-deleting="true"
:allow-updating="true"
v-model:changes="changes"
v-model:edit-row-key="editRowKey"
/>
<DxPager :visible="true"/>
<DxColumn
data-field="OrderID"
:allow-editing="false"
/>
<DxColumn data-field="ShipName"/>
<DxColumn data-field="ShipCountry"/>
<DxColumn data-field="ShipCity"/>
<DxColumn data-field="ShipAddress"/>
<DxColumn
data-field="OrderDate"
data-type="date"
/>
<DxColumn data-field="Freight"/>
</DxDataGrid>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Edit Row Key:</span>
<div id="editRowKey">{{ editRowKey === null ? "null" : editRowKey.toString() }}</div>
</div>
<div class="option">
<span>Changes:</span>
<div id="changes">{{ changesText }}</div>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { computed } from 'vue';
import { useStore } from 'vuex';
import {
DxDataGrid, DxColumn, DxEditing, type DxDataGridTypes, DxPager,
} from 'devextreme-vue/data-grid';
import { DxLoadPanel } from 'devextreme-vue/load-panel';
import { type State } from './store.ts';
const loadPanelPosition = { of: '#gridContainer' };
const store = useStore<State>();
const loadOrders = () => store.dispatch('loadOrders');
const setEditRowKey = (value: number | null) => store.dispatch('setEditRowKey', value);
const setChanges = (value: DxDataGridTypes.DataChange[]) => store.dispatch('setChanges', value);
const saveChange = (change: DxDataGridTypes.DataChange) => store.dispatch('saveChange', change);
const orders = computed(() => store.state.orders);
const isLoading = computed(() => store.state.isLoading);
const changes = computed({
get: () => (store.state.changes),
set: (value) => { setChanges(value); },
});
const editRowKey = computed({
get: () => store.state.editRowKey,
set: (value) => { setEditRowKey(value); },
});
const changesText = computed(() => JSON.stringify(changes.value.map((change) => ({
type: change.type,
key: change.type !== 'insert' ? change.key : undefined,
data: change.data,
})), null, ' '));
const onSaving = (e: DxDataGridTypes.SavingEvent) => {
e.cancel = true;
e.promise = saveChange(e.changes[0]);
};
loadOrders();
</script>
<style scoped>
#gridContainer {
height: 440px;
}
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
margin-bottom: 10px;
font-weight: 500;
font-size: 18px;
}
.option {
margin-bottom: 10px;
}
.option > span {
position: relative;
margin-right: 14px;
}
.option > div {
display: inline-block;
font-weight: bold;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'whatwg-fetch': 'npm:whatwg-fetch@2.0.4/fetch.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'vuex': 'npm:vuex@4.0.0-beta.4/dist/vuex.esm-browser.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
export type Order = {
OrderID: number;
ShipName: string;
ShipCountry: string;
ShipCity: string;
ShipAddress: string;
OrderDate: string;
Freight: number;
};
import { createApp } from 'vue';
import App from './App.vue';
import store from './store.ts';
createApp(App).use(store).mount('#app');
import { createStore } from 'vuex';
import 'whatwg-fetch';
import applyChanges from 'devextreme/data/apply_changes';
import { type DataChange } from 'devextreme/ui/data_grid';
import { sendRequest } from './utils.ts';
import { type Order } from './data.ts';
const URL = 'https://js.devexpress.com/Demos/NetCore/api/DataGridWebApi';
export type State = {
orders: Order[],
changes: DataChange[],
editRowKey: number | null,
isLoading: boolean,
};
export default createStore<State>({
state: {
orders: [],
changes: [],
editRowKey: null,
isLoading: false,
},
mutations: {
updateIsLoading(state, isLoading: boolean) {
state.isLoading = isLoading;
},
updateEditRowKey(state, editRowKey: number | null) {
state.editRowKey = editRowKey;
},
updateChanges(state, changes: DataChange[]) {
state.changes = changes;
},
updateOrders(state, orders: Order[]) {
state.orders = orders;
},
applyChangeToOrders(state, payload: { change: DataChange, data: Order }) {
const { change, data } = payload;
change.data = data;
state.orders = applyChanges(state.orders, [change], { keyExpr: 'OrderID' });
},
},
actions: {
setEditRowKey(context, value: number | null) {
context.commit('updateEditRowKey', value);
},
setChanges(context, value: DataChange[]) {
context.commit('updateChanges', value);
},
async loadOrders(context) {
context.commit('updateIsLoading', true);
try {
const { data: orders } = await sendRequest(`${URL}/Orders?skip=700`);
context.commit('updateOrders', orders);
} finally {
context.commit('updateIsLoading', false);
}
},
async insert(context, change: DataChange) {
const newOrder = await sendRequest(`${URL}/InsertOrder`, 'POST', {
values: JSON.stringify(change.data),
});
context.commit('applyChangeToOrders', { change, data: newOrder });
},
async update(context, change: DataChange) {
const updatedOrder = await sendRequest(`${URL}/UpdateOrder`, 'PUT', {
key: change.key,
values: JSON.stringify(change.data),
});
context.commit('applyChangeToOrders', { change, data: updatedOrder });
},
async remove(context, change: DataChange) {
const data = await sendRequest(`${URL}/DeleteOrder`, 'DELETE', { key: change.key });
context.commit('applyChangeToOrders', { change, data });
},
async saveChange({ commit, dispatch }, change: DataChange) {
if (change?.type) {
commit('updateIsLoading', true);
try {
await dispatch(change.type, change);
} finally {
commit('updateIsLoading', false);
}
}
commit('updateEditRowKey', null);
commit('updateChanges', []);
},
},
});
export async function sendRequest(url: string, method = 'GET', data: Record<string, string> = {}) {
const params = Object.keys(data)
.map((key) => `${encodeURIComponent(key)}=${encodeURIComponent(data[key])}`)
.join('&');
const result = await fetch(url, {
method,
body: params || null,
headers: method === 'GET'
? {}
: { 'Content-Type': 'application/x-www-form-urlencoded;charset=UTF-8' },
credentials: 'include',
});
if (result.ok) {
const text = await result.text();
return text && JSON.parse(text);
}
const json = await result.json();
throw json.Message;
}
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app" />
</div>
</body>
</html>

import React, {
useCallback, useEffect, useMemo, useReducer,
} from 'react';
import 'whatwg-fetch';
import DataGrid, { Column, Editing, Pager } from 'devextreme-react/data-grid';
import type { DataGridTypes } from 'devextreme-react/data-grid';
import { LoadPanel } from 'devextreme-react/load-panel';
import reducer from './reducer.ts';
import type { State } from './reducer.ts';
import {
saveChange, loadOrders, setChanges, setEditRowKey,
} from './actions.ts';
const initialState: State = {
data: [],
changes: [],
editRowKey: null,
isLoading: false,
};
const loadPanelPosition = { of: '#gridContainer' };
const App = () => {
const [state, dispatch] = useReducer(reducer, initialState);
const changesText = useMemo(() => JSON.stringify(state.changes.map((change: DataGridTypes.DataChange) => ({
type: change.type,
key: change.type !== 'insert' ? change.key : undefined,
data: change.data,
})), null, ' '), [state.changes]);
useEffect(() => {
loadOrders(dispatch);
}, []);
const onSaving = useCallback((e: DataGridTypes.SavingEvent) => {
e.cancel = true;
e.promise = saveChange(dispatch, e.changes[0]);
}, []);
const onChangesChange = useCallback((changes: DataGridTypes.DataChange[]) => {
setChanges(dispatch, changes);
}, []);
const onEditRowKeyChange = useCallback((editRowKey) => {
setEditRowKey(dispatch, editRowKey);
}, []);
return (
<>
<LoadPanel
position={loadPanelPosition}
visible={state.isLoading}
/>
<DataGrid
id="gridContainer"
keyExpr="OrderID"
dataSource={state.data}
showBorders
repaintChangesOnly
onSaving={onSaving}>
<Editing
mode="row"
allowAdding
allowDeleting
allowUpdating
changes={state.changes}
onChangesChange={onChangesChange}
editRowKey={state.editRowKey}
onEditRowKeyChange={onEditRowKeyChange}
/>
<Pager visible={true} />
<Column dataField="OrderID" allowEditing={false}></Column>
<Column dataField="ShipName"></Column>
<Column dataField="ShipCountry"></Column>
<Column dataField="ShipCity"></Column>
<Column dataField="ShipAddress"></Column>
<Column dataField="OrderDate" dataType="date"></Column>
<Column dataField="Freight"></Column>
</DataGrid>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<span>Edit Row Key:</span>
<div id="editRowKey">{state.editRowKey === null ? 'null' : state.editRowKey.toString()}</div>
</div>
<div className="option">
<span>Changes:</span>
<div id="changes">{changesText}</div>
</div>
</div>
</>
);
};
export default App;
import React, {
useCallback, useEffect, useMemo, useReducer,
} from 'react';
import 'whatwg-fetch';
import DataGrid, { Column, Editing, Pager } from 'devextreme-react/data-grid';
import { LoadPanel } from 'devextreme-react/load-panel';
import reducer from './reducer.js';
import {
saveChange, loadOrders, setChanges, setEditRowKey,
} from './actions.js';
const initialState = {
data: [],
changes: [],
editRowKey: null,
isLoading: false,
};
const loadPanelPosition = { of: '#gridContainer' };
const App = () => {
const [state, dispatch] = useReducer(reducer, initialState);
const changesText = useMemo(
() =>
JSON.stringify(
state.changes.map((change) => ({
type: change.type,
key: change.type !== 'insert' ? change.key : undefined,
data: change.data,
})),
null,
' ',
),
[state.changes],
);
useEffect(() => {
loadOrders(dispatch);
}, []);
const onSaving = useCallback((e) => {
e.cancel = true;
e.promise = saveChange(dispatch, e.changes[0]);
}, []);
const onChangesChange = useCallback((changes) => {
setChanges(dispatch, changes);
}, []);
const onEditRowKeyChange = useCallback((editRowKey) => {
setEditRowKey(dispatch, editRowKey);
}, []);
return (
<>
<LoadPanel
position={loadPanelPosition}
visible={state.isLoading}
/>
<DataGrid
id="gridContainer"
keyExpr="OrderID"
dataSource={state.data}
showBorders
repaintChangesOnly
onSaving={onSaving}
>
<Editing
mode="row"
allowAdding
allowDeleting
allowUpdating
changes={state.changes}
onChangesChange={onChangesChange}
editRowKey={state.editRowKey}
onEditRowKeyChange={onEditRowKeyChange}
/>
<Pager visible={true} />
<Column
dataField="OrderID"
allowEditing={false}
></Column>
<Column dataField="ShipName"></Column>
<Column dataField="ShipCountry"></Column>
<Column dataField="ShipCity"></Column>
<Column dataField="ShipAddress"></Column>
<Column
dataField="OrderDate"
dataType="date"
></Column>
<Column dataField="Freight"></Column>
</DataGrid>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<span>Edit Row Key:</span>
<div id="editRowKey">
{state.editRowKey === null ? 'null' : state.editRowKey.toString()}
</div>
</div>
<div className="option">
<span>Changes:</span>
<div id="changes">{changesText}</div>
</div>
</div>
</>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import React from 'react';
import type { DataGridTypes } from 'devextreme-react/data-grid';
import { sendRequest } from './utils.ts';
const URL = 'https://js.devexpress.com/Demos/NetCore/api/DataGridWebApi';
export const FETCH_PENDING = 'FETCH_PENDING';
export const FETCH_SUCCESS = 'FETCH_SUCCESS';
export const FETCH_ERROR = 'FETCH_ERROR';
export const SAVING_PENDING = 'SAVING_PENDING';
export const SAVING_SUCCESS = 'SAVING_SUCCESS';
export const SAVING_ERROR = 'SAVING_ERROR';
export const SAVING_CANCEL = 'SAVING_CANCEL';
export const SET_CHANGES = 'SET_CHANGES';
export const SET_EDIT_ROW_KEY = 'SET_EDIT_ROW_KEY';
type dispatchType = React.Dispatch<{ type: any, payload?: any }>;
export async function loadOrders(dispatch: dispatchType) {
dispatch({ type: FETCH_PENDING });
try {
const { data } = await sendRequest(`${URL}/Orders?skip=700`);
dispatch({
type: FETCH_SUCCESS,
payload: {
data,
},
});
} catch (err) {
dispatch({ type: FETCH_ERROR });
throw err;
}
}
export async function saveChange(dispatch: dispatchType, change: DataGridTypes.DataChange) {
if (change?.type) {
let data;
dispatch({ type: SAVING_PENDING });
try {
data = await sendChange(URL, change);
change.data = data;
dispatch({
type: SAVING_SUCCESS,
payload: {
change,
},
});
return data;
} catch (err) {
dispatch({ type: SAVING_ERROR });
throw err;
}
} else {
dispatch({ type: SAVING_CANCEL });
return null;
}
}
function sendChange(url: string, change: DataGridTypes.DataChange) {
switch (change.type) {
case 'insert':
return sendRequest(`${url}/InsertOrder`, 'POST', {
values: JSON.stringify(change.data),
});
case 'update':
return sendRequest(`${url}/UpdateOrder`, 'PUT', {
key: change.key,
values: JSON.stringify(change.data),
});
case 'remove':
return sendRequest(`${url}/DeleteOrder`, 'DELETE', { key: change.key });
default:
return null;
}
}
export function setChanges(dispatch: dispatchType, changes: DataGridTypes.DataChange[]) {
dispatch({
type: SET_CHANGES,
payload: changes,
});
}
export function setEditRowKey(dispatch: dispatchType, editRowKey: any) {
dispatch({
type: SET_EDIT_ROW_KEY,
payload: editRowKey,
});
}
import applyChanges from 'devextreme/data/apply_changes';
import type { DataGridTypes } from 'devextreme-react/data-grid';
import {
FETCH_PENDING,
FETCH_SUCCESS,
FETCH_ERROR,
SAVING_PENDING,
SAVING_SUCCESS,
SAVING_ERROR,
SAVING_CANCEL,
SET_CHANGES,
SET_EDIT_ROW_KEY,
} from './actions.ts';
export interface State {
data: any[];
editRowKey: any;
changes: DataGridTypes.DataChange[];
isLoading: boolean;
}
interface Action {
type: string;
payload?: any;
}
export default function reducer(state: State, { type, payload }: Action) {
let newData;
switch (type) {
case SAVING_SUCCESS:
newData = applyChanges(state.data, [payload.change], { keyExpr: 'OrderID' });
return {
...state,
data: newData,
changes: [],
editRowKey: null,
isLoading: false,
};
case SAVING_CANCEL:
return {
...state,
changes: [],
editRowKey: null,
};
case SET_CHANGES:
return {
...state,
changes: payload,
};
case SET_EDIT_ROW_KEY:
return {
...state,
editRowKey: payload,
};
case FETCH_SUCCESS:
return {
...state,
...payload,
isLoading: false,
};
case FETCH_PENDING:
case SAVING_PENDING:
return {
...state,
isLoading: true,
};
case FETCH_ERROR:
case SAVING_ERROR:
return {
...state,
isLoading: false,
};
default:
return state;
}
}
export async function sendRequest(url: string, method = 'GET', data: Record<string, any> = {}) {
const params = Object.keys(data)
.map((key) => `${encodeURIComponent(key)}=${encodeURIComponent(data[key])}`)
.join('&');
const result = await fetch(url, {
method,
body: params || null,
headers:
method === 'GET'
? {}
: {
'Content-Type': 'application/x-www-form-urlencoded;charset=UTF-8',
},
credentials: 'include',
});
if (result.ok) {
const text = await result.text();
return text && JSON.parse(text);
}
const json = await result.json();
throw json.Message;
}
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'whatwg-fetch': 'npm:whatwg-fetch@2.0.4/fetch.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import { sendRequest } from './utils.js';
const URL = 'https://js.devexpress.com/Demos/NetCore/api/DataGridWebApi';
export const FETCH_PENDING = 'FETCH_PENDING';
export const FETCH_SUCCESS = 'FETCH_SUCCESS';
export const FETCH_ERROR = 'FETCH_ERROR';
export const SAVING_PENDING = 'SAVING_PENDING';
export const SAVING_SUCCESS = 'SAVING_SUCCESS';
export const SAVING_ERROR = 'SAVING_ERROR';
export const SAVING_CANCEL = 'SAVING_CANCEL';
export const SET_CHANGES = 'SET_CHANGES';
export const SET_EDIT_ROW_KEY = 'SET_EDIT_ROW_KEY';
export async function loadOrders(dispatch) {
dispatch({ type: FETCH_PENDING });
try {
const { data } = await sendRequest(`${URL}/Orders?skip=700`);
dispatch({
type: FETCH_SUCCESS,
payload: {
data,
},
});
} catch (err) {
dispatch({ type: FETCH_ERROR });
throw err;
}
}
export async function saveChange(dispatch, change) {
if (change?.type) {
let data;
dispatch({ type: SAVING_PENDING });
try {
data = await sendChange(URL, change);
change.data = data;
dispatch({
type: SAVING_SUCCESS,
payload: {
change,
},
});
return data;
} catch (err) {
dispatch({ type: SAVING_ERROR });
throw err;
}
} else {
dispatch({ type: SAVING_CANCEL });
return null;
}
}
function sendChange(url, change) {
switch (change.type) {
case 'insert':
return sendRequest(`${url}/InsertOrder`, 'POST', {
values: JSON.stringify(change.data),
});
case 'update':
return sendRequest(`${url}/UpdateOrder`, 'PUT', {
key: change.key,
values: JSON.stringify(change.data),
});
case 'remove':
return sendRequest(`${url}/DeleteOrder`, 'DELETE', { key: change.key });
default:
return null;
}
}
export function setChanges(dispatch, changes) {
dispatch({
type: SET_CHANGES,
payload: changes,
});
}
export function setEditRowKey(dispatch, editRowKey) {
dispatch({
type: SET_EDIT_ROW_KEY,
payload: editRowKey,
});
}
import applyChanges from 'devextreme/data/apply_changes';
import {
FETCH_PENDING,
FETCH_SUCCESS,
FETCH_ERROR,
SAVING_PENDING,
SAVING_SUCCESS,
SAVING_ERROR,
SAVING_CANCEL,
SET_CHANGES,
SET_EDIT_ROW_KEY,
} from './actions.js';
export default function reducer(state, { type, payload }) {
let newData;
switch (type) {
case SAVING_SUCCESS:
newData = applyChanges(state.data, [payload.change], { keyExpr: 'OrderID' });
return {
...state,
data: newData,
changes: [],
editRowKey: null,
isLoading: false,
};
case SAVING_CANCEL:
return {
...state,
changes: [],
editRowKey: null,
};
case SET_CHANGES:
return {
...state,
changes: payload,
};
case SET_EDIT_ROW_KEY:
return {
...state,
editRowKey: payload,
};
case FETCH_SUCCESS:
return {
...state,
...payload,
isLoading: false,
};
case FETCH_PENDING:
case SAVING_PENDING:
return {
...state,
isLoading: true,
};
case FETCH_ERROR:
case SAVING_ERROR:
return {
...state,
isLoading: false,
};
default:
return state;
}
}
export async function sendRequest(url, method = 'GET', data = {}) {
const params = Object.keys(data)
.map((key) => `${encodeURIComponent(key)}=${encodeURIComponent(data[key])}`)
.join('&');
const result = await fetch(url, {
method,
body: params || null,
headers:
method === 'GET'
? {}
: {
'Content-Type': 'application/x-www-form-urlencoded;charset=UTF-8',
},
credentials: 'include',
});
if (result.ok) {
const text = await result.text();
return text && JSON.parse(text);
}
const json = await result.json();
throw json.Message;
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#gridContainer {
height: 440px;
}
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
margin-bottom: 10px;
font-weight: 500;
font-size: 18px;
}
.option {
margin-bottom: 10px;
}
.option > span {
position: relative;
margin-right: 14px;
}
.option > div {
display: inline-block;
font-weight: bold;
}